""" The loopy specific generators """
from __future__ import absolute_import

from dune.perftool.generation import generator_factory

import loopy
import numpy

iname = generator_factory(item_tags=("loopy", "kernel", "iname"))
expr_instruction = generator_factory(item_tags=("loopy", "kernel", "instruction", "exprinstruction"), no_deco=True)
temporary_variable = generator_factory(item_tags=("loopy", "kernel", "temporary"), on_store=lambda n: loopy.TemporaryVariable(n, dtype=numpy.float64), no_deco=True)
c_instruction = generator_factory(item_tags=("loopy", "kernel", "instruction", "cinstruction"), no_deco=True)
valuearg = generator_factory(item_tags=("loopy", "kernel", "argument", "valuearg"), on_store=lambda n: loopy.ValueArg(n), no_deco=True)


@generator_factory(item_tags=("loopy", "kernel", "argument", "globalarg"))
def globalarg(name, shape=loopy.auto):
    if isinstance(shape, str):
        shape = (shape,)
    return loopy.GlobalArg(name, numpy.float64, shape)


@generator_factory(item_tags=("loopy", "kernel", "domain"))
def domain(iname, shape):
    if isinstance(shape, str):
        valuearg(shape)
    return "{{ [{0}] : 0<={0}<{1} }}".format(iname, shape)
