""" Generator functions related to trial and test functions and the accumulation loop"""

from dune.perftool.generation import symbol
from dune.perftool.ufl.modified_terminals import ModifiedArgumentDescriptor


@symbol
def name_testfunction(ma):
    if len(ma.argexpr.element().sub_elements()) > 0:
        pass
    return "{}a{}".format("grad_" if ma.grad else "", ma.argexpr.number())


@symbol
def name_trialfunction(ma):
    return "{}c{}".format("grad_" if ma.grad else "", ma.argexpr.count())


@symbol
def name_testfunctionspace(*a):
    # TODO
    return "lfsv"


@symbol
def name_trialfunctionspace(*a):
    # TODO
    return "lfsu"


def name_argumentspace(ma):
    if ma.argexpr.number() == 0:
        return name_testfunctionspace(ma)
    if ma.argexpr.number() == 1:
        return name_trialfunctionspace(ma)
    # We should never encounter an argument other than 0 or 1
    assert False


def name_argument(ma):
    if ma.argexpr.number() == 0:
        return name_testfunction(ma)
    if ma.argexpr.number() == 1:
        return name_trialfunction(ma)
    # We should never encounter an argument other than 0 or 1
    assert False


@symbol
def name_residual():
    return "r"
